=== debian/changelog ===
mame (0.282+dfsg1-1) unstable; urgency=medium

  [ Cesare Falco ]
  * New upstream release.

  [ Jordi Mallach ]
  * Add -mcmodel=medium to CFLAGS to fix builds on loong64.
    Thanks, Dandan Zhang (closes: #1119717).

 -- Jordi Mallach <jordi@debian.org>  Tue, 11 Nov 2025 23:28:28 +0100
