## mame 0.283+dfsg1

=== debian/changelog ===
mame (0.283+dfsg1-0.1~mx25) mx; urgency=medium

  * New upstream release

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 04 Dec 2025 07:43:32 -0800

mame (0.282+dfsg1-0.1~mx25) mx; urgency=medium

  * New upstream release

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 02 Nov 2025 19:43:45 -0800

mame (0.281+dfsg1-1~mx25+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 02 Oct 2025 14:25:58 -0700
