## mame 0.284+dfsg1

=== debian/changelog ===
mame (0.284+dfsg1-1) unstable; urgency=medium

  [ Cesare Falco ]
  * New upstream release.

  [ Jordi Mallach ]
  * Drop redundant Rules-Requires-Root control field.
  * Rewrite watch file in v5 format.
  * Remove redundant Priority control field.

 -- Jordi Mallach <jordi@debian.org>  Thu, 08 Jan 2026 22:38:56 +0100

mame (0.283+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Cesare Falco <c.falco@ubuntu.com>  Tue, 02 Dec 2025 15:26:45 +0100
