=== debian/watch ===
Version: 5
Source: https://github.com/mamedev/mame/tags/
Matching-Pattern: .+@PACKAGE@(\d)(\d{3}).tar.gz
Dversion-Mangle: auto
Repack: yes
Repacksuffix: +dfsg1
Compression: xz
