## mame 0.285+dfsg1

=== debian/changelog ===
mame (0.285+dfsg1-1) unstable; urgency=medium

  [ Cesare Falco ]
  * New upstream release.
  * Update patches.

  [ Jordi Mallach ]
  * Stop linking with binutils-gold for arm64. (Closes: #1121717)

 -- Jordi Mallach <jordi@debian.org>  Thu, 12 Feb 2026 23:29:36 +0100
