=== debian/control ===
--- 
+++ 
@@ -5,7 +5,6 @@
  Emmanuel Kasper <emmanuel@libera.cc>,
  Jordi Mallach <jordi@debian.org>
 Build-Depends: debhelper-compat (= 13),
- binutils-gold [arm64],
  dpkg-dev (>= 1.17),
  libasio-dev (>= 1.20),
  libexpat1-dev,
