=== debian/rules ===
--- 
+++ 
@@ -80,7 +80,6 @@
 ifeq ($(DEB_HOST_ARCH),arm64)
 DEB_OPTS += \
     ARCHOPTS="-mabi=lp64 -fPIC"
-LINK_WITH_GOLD = 1
 ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
 # reduce jobs to release memory on Launchpad builder VM
 NUMJOBS = 2
@@ -216,14 +215,9 @@
 CFLAGS := $(patsubst -Werror=implicit-function-declaration,-Wno-error=implicit-function-declaration,$(CFLAGS))
 endif
 
-ifdef LINK_WITH_GOLD
-export DEB_LDFLAGS_MAINT_PREPEND += \
-    -fuse-ld=gold -Wl,--no-keep-memory
-else
 # Sacrifice linking speed to avoid using so much memory
 export DEB_LDFLAGS_MAINT_APPEND += \
     -Wl,--no-keep-memory,--reduce-memory-overheads,--hash-size=31
-endif
 
 ifdef NUMJOBS
 MAKEFLAGS += -j$(NUMJOBS)
