## mame 0.286+dfsg1

=== debian/changelog ===
mame (0.286+dfsg1-1) unstable; urgency=medium

  [ Cesare Falco ]
  * New upstream release.
  * Update patches.

  [ Jordi Mallach ]
  * Update Standards-Version to 4.7.3, with no changes needed.

 -- Jordi Mallach <jordi@debian.org>  Tue, 03 Mar 2026 09:26:36 +0100
