=== debian/control ===
--- 
+++ 
@@ -29,7 +29,7 @@
 Build-Depends-Indep: python3-sphinx,
  python3-sphinxcontrib.svg2pdfconverter,
  sphinx-rtd-theme-common
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Git: https://salsa.debian.org/games-team/mame.git
 Vcs-Browser: https://salsa.debian.org/games-team/mame
 Homepage: https://mamedev.org/
